package transformers;


import com.opencsv.CSVWriter;
import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVParser;
import org.apache.commons.csv.CSVRecord;
import org.apache.log4j.Logger;
import simulation.Simulation;
import utils.HumanActivity;

import java.io.*;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * This class is able to consume the 4 sensors nodes files generated by the sensor nodes and create an unique CSV file
 * which contains the whole data, ordered by the timestamp.
 * <p>
 * There is a MAJOR assumption here: the provided data is synchronised. This means that, in the file S1data.csv the feed
 * with the time, i.e., 25.10 is being sent to the Esper CEP engine at the same time that the feed with the same time but
 * in the file S2data.csv or S3data.csv or S4data.csv. For me, here, it is impossible to determine if this is true or not,
 * but it must be true in order to guarantee the proper functionality of the patterns. In other words, the sensors nodes are
 * synchronised and are producing and sending the data in the same time and in real time to the Esper CEP engine.
 * <p>
 * If you want to process data from 6 nodes, lines 47 and 48 should be uncommented.
 *
 * @author David Corral-Plaza <david.corral@uca.es>
 */
public class ProcessCSV {

    static public Logger logger = Logger.getLogger(Simulation.class);

    public static void main(String[] args) throws IOException {
        List<HumanActivity> sensorReads = new ArrayList<HumanActivity>();
        String[] falls = new String[]{"backfall", "frontfall", "leftfall", "rightfall"};
        for (String f : falls) {
            String path = ".\\assets\\april-luigi\\4nodes\\" + f + "\\";

            sensorReads.addAll(readCsvFile(path + "S1data.csv", 1));
            sensorReads.addAll(readCsvFile(path + "S2data.csv", 2));
            sensorReads.addAll(readCsvFile(path + "S3data.csv", 3));
            sensorReads.addAll(readCsvFile(path + "S4data.csv", 4));
            //sensorReads.addAll(readCsvFile(path + "S5data.csv", 5));
            //sensorReads.addAll(readCsvFile(path + "S6data.csv", 6));
            Collections.sort(sensorReads, new HumanActivity.OrderByTimestamp());
            convertJavaList2CSVFile(sensorReads, Paths.get("src/main/resources/april-luigi/4nodes/april-luigi-6nodes-" + f + ".csv"));
            sensorReads.clear();
        }
    }

    private static List<HumanActivity> readCsvFile(String filePath, int sensorId) {
        List<HumanActivity> sensorReads = new ArrayList<HumanActivity>();

        try {
            BufferedReader fileReader = new BufferedReader(new FileReader(filePath));
            CSVParser csvParser = new CSVParser(fileReader,
                    CSVFormat.DEFAULT.withFirstRecordAsHeader().withIgnoreHeaderCase().withTrim());

            Iterable<CSVRecord> csvRecords = csvParser.getRecords();
            for (CSVRecord csvRecord : csvRecords) {
                HumanActivity HumanActivity = new HumanActivity(
                        sensorId,
                        Double.parseDouble(csvRecord.get("A-Mag[G]")),
                        Double.parseDouble(csvRecord.get("A-x[G]")),
                        Double.parseDouble(csvRecord.get("A-y[G]")),
                        Double.parseDouble(csvRecord.get("A-z[G]")),
                        Double.parseDouble(csvRecord.get("G-Mag[rad/s]")),
                        Double.parseDouble(csvRecord.get("G-x[rad/s]")),
                        Double.parseDouble(csvRecord.get("G-y[rad/s]")),
                        Double.parseDouble(csvRecord.get("G-z[rad/s]")),
                        Math.round((Double.parseDouble(csvRecord.get("Time[s]")) * 1000))
                );

                sensorReads.add(HumanActivity);
            }
            fileReader.close();
            csvParser.close();
        } catch (Exception e) {
            logger.error("Reading CSV Error!");
            e.printStackTrace();
        }

        return sensorReads;
    }

    public static void convertJavaList2CSVFile(List<HumanActivity> sensorReads, Path path) throws IOException {
        CSVWriter writer = new CSVWriter(new FileWriter(path.toString()));
        writer.writeNext(new String[]{"p1", "p2", "p3", "p4", "p5", "p6", "p7", "p8", "p9", "p10", "timestamp"});
        for (HumanActivity h : sensorReads) {
            writer.writeNext(h.getObject());
        }

        writer.close();
    }
}
